#include "../generic_algs/chain_constraints.hh"
#include "../group/group_constraint_interface.hh"

#include "bd_constrainer.hh"

namespace Browndye{
  
  Constrainer::Constrainer( const System& sys){
    //doer = std::make_unique< Doer>( sys);
    doer = new Doer( sys);
  }
  
  Constrainer::~Constrainer(){
    delete doer;
  }
  
  Constrainer::Constrainer( Constrainer&& other){
    doer = other.doer;
    other.doer = nullptr;
  }
  
  Constrainer& Constrainer::operator=( Constrainer&& other){
    doer = other.doer;
    other.doer = nullptr;
    return *this;
  }
    
  double Constrainer::sys_rms_violation( const System& sys){
    return doer->sys_rms_violation( sys);
  }
  
  void Constrainer::satisfy_no_init( System& sys, double tol){
    doer->satisfy_no_init( sys, tol);
  }
  
  void Constrainer::satisfy( System& sys, double tol, size_t& nsteps){
    doer->satisfy( sys, tol, nsteps);
  }

  [[maybe_unused]] void Constrainer::satisfy_simple( System& sys, double tol, size_t& nsteps){
    doer->satisfy_simple( sys, tol, nsteps);
  }
}
